      PROGRAM isoAbund

C -------------------------------------------------
C -- The user enters a list of isotopes which has
C -- to be in the five-character format used by NUCLEO.
C -- The program then searches through NUCLEO.OUT once 
C -- for each isotope, extracting the time dependence 
C -- of the abundance.  Abundance is in terms of X, 
C -- i.e. grams of isotope per grams of total stellar 
C -- material. These time evolutions are printed to
C -- ISOABUND.OUT in column format.
CC -------------------------------------------------

      INTEGER J, K,i,entries,nis,isonum,nstep,nflag
      CHARACTER*(132) INSTRING
      CHARACTER*(16) TIME(100000) 
      double precision X(100000,1000),xiso(100000,1000)
      double precision xelem(100)
      character*(5) ON(1000),onhelp
      character*(5) ISO(7)
c      character*(2) elem(100)
      character*(1) response
      character*40 netoutfile
      
      netoutfile='nucleo.out'
           
      write(6,9333)netoutfile
      read(5,9444) response
      if ((index(response,'y').ne.0).or.
     *    (index(response,'Y').ne.0)) then
         write(6,*)' Enter new filename:'
	 read(5,9444)netoutfile
      endif
9333  format(/,10x,'Change network output file? [Y/N]',/,10x,      
     *         '(Default: ',a,' )')
9444  format(a)      

      OPEN (UNIT=10,FILE=netoutfile,STATUS='unknown')
      OPEN (UNIT=11,FILE='isoAbund.out',STATUS='UNKNOWN')

      J  = 0
      K  = 0
      i=0
      
c     i: isotope
c     k: user input isotope
c     j: time step  
c     l: string analysis 
c     nstep: number of time steps 
c     m: element  

C -----------------------------------------------
C     get isotope strings from user input
C -----------------------------------------------
      write(6,9334)
      read(5,*) isonum      
      if(isonum.eq.0) goto 91
      
      write(6,9335)
      do 150 k=1,isonum
        read(5,230) iso(k)
  150 continue	
      
      write(11,9336) (iso(k),k=1,isonum)
      
 9334 format(/,10x,'Enter number of isotopes (max. 7):')     
 9335 format(/,10x,'Enter isotopes in format NI 56:')
  230 format(a5)
 9336 format(7x,'t(s)',10x,7(a5,4x))

   91 continue

c -----------------------------------------------
c     read input file
c -----------------------------------------------

      OPEN (UNIT=10,FILE=netoutfile,STATUS='OLD')

c     read number of isotopes
   20 READ(10,1000) INSTRING
      l=index(instring,'number of nuclides')
      if(l.ne.0) then
         read(instring,998) nis
         goto 22
        else
         goto 20
      endif
  998 format(24x,i5) 
   22 continue
   
   30 READ(10,1000,end=25) INSTRING
      l = INDEX(INSTRING,'T = ')
      IF (l .NE. 0) THEN 
          j=j+1
          TIME(j) = INSTRING(l+4:l+19)
          read(10,*)
          read(10,*)
          read(10,*)
          read(10,*)
          read(10,*)
          read(10,*)
          read(10,9998) (ON(i),X(j,i),i=1,nis)          
      endif

      goto 30
            
   25 continue
      nstep=j

  600 continue      
c     cccccccccccccccccccccccccccccccccccccccccccccccccc

 1000 FORMAT(A132)
 9998 FORMAT(9(1X,a5,1x,1pE10.2E3))

c -----------------------------------------------
c     analyze data
c -----------------------------------------------

c      if(isonum.ne.0) then
c       time versus isotope abundance output
        do 101 k=1,isonum
          do 102 i=1,nis  
            if(on(i).eq.iso(k)) then
               do 103 j=1,nstep
                  xiso(j,k)=x(j,i)
                  if(xiso(j,k).le.0.d0)then
                     xiso(j,k)=1.0d-99      ! to avoid negative and zero abundances 
                  endif
  103          continue
            endif
  102     continue
  101   continue
         
        do 84 j=1,nstep
           write(11,1232) time(j),(xiso(j,i),i=1,isonum)
   84   continue
c       else                
                           
c      endif
 1232 format(1x,a16,7(2x,1pE9.2E3))

      stop
      END

